DEBUG = false

function DebugPrint(msg)
	if DEBUG then
		Print(msg)
	end
end

------------------------------------------------------------
-- Simulation file for the SEC
------------------------------------------------------------

------------------------------------------------------------
-- Update
------------------------------------------------------------
-- Called every frame to update the simulation
------------------------------------------------------------
-- Parameters:
--	inteval = time since last update
------------------------------------------------------------

function Setup()

	gCurrentTime = 0
	gLastTime = 0
	gLastSpeed = 0
	gDampedAcceleration = {}
	for i=0, 24 do
		gDampedAcceleration[i] = 0
	end
	gAccelerationindex = 0


end

function Update( interval )

	gCurrentTime = Call( "*:GetSimulationTime", 0 )
	Speed = Call( "*:GetControlValue", "SpeedometerMPH", 0 )

-- Calculate acceleration. milesperhourpersecond.
	gDampedAcceleration[gAccelerationindex] = (Speed - gLastSpeed) / (gCurrentTime - gLastTime)
        gLastTime = gCurrentTime
	gLastSpeed = Speed

	gAccelerationindex = gAccelerationindex + 1
	if (gAccelerationindex == 25) then
		gAccelerationindex = 0
	end

	DampedValue = 0
	for i=0, 24 do
		DampedValue = DampedValue + gDampedAcceleration[i]
	end
	DampedValue = DampedValue / 25

	Call( "*:SetControlValue", "Acceleration", 0, DampedValue )

end

function Initialise()

end

