-----------------------------------------------------------
-- Class 220 Script 
-----------------------------------------------------------

function Initialise() --Called once when sim first loads

	isDebugOn = false
	
	if isDebugOn then
		file = io.open("../railworks/Assets/JustTrains/Voyager/RailVehicles/Diesel/221/Default/Engine/debug"..gCoachLetter..".txt","w")
	end
	
	COMPAT_MSG_RPM = 22101 --Message ID for RPM
	COMPAT_MSG_START = 22104 --Message ID for startup/shutdown
	COMPAT_MSG_BLIND = 22105 --Message ID for blind position
	COMPAT_MSG_FAIL = 22106 --Message ID for engine failure
	COMPAT_MSG_TILT = 22107 --Message ID for tilt on/off
	COMPAT_MSG_BOOTSTATE = 22108 --Message ID for tilt on/off
	COMPAT_MSG_COLDSTART = 22110 --Message for cold start trigger
	COMPAT_MSG_TASSENABLED = 22111 --Message for cold start trigger
	COMPAT_MSG_TASSFAILED = 22112
	JT_SCENARIO_MESSAGE	= 101 --Message ID for scenario trigger points

	isExpert = false
	isExpertChecked = false
	gDoorInterlockTimer = 0 --Countdown time for door interlock release
	isDoorsInterlocked = true --Door interlock controller
	isPlayerLoco = false --Is this the driven unit
	isPlayerConsist = false --Is this the driven consist
	isSlipping = false --Is the unit wheelslipping
	isAWSTestInProgress = false --AWS test sequence
	isAWSTested = false --AWS test sequence completed
	gRunningTime = 0 --Time since unit initialised
	gpreviousSpeed = 0 --Previous frame speed (m/s)
	isDRASet = true --DRA monitor
	DSDDELAY = 60 --DSD alarm countdown timer
	gDSDCount = 0 --DSD alarm timer
	isDSDTriggered = false --DSD monitor
	isSafetyIsolated = false --DSD isolation monitor
	isKeyIn = false --Driver's key monitor
	isReverserDSDReset = true --DSD alarm reset when reverser 
	gLastReverserValue = 0 --Previous allowed reverser value
	gLastFrameReverserValue = 0 -- Reverser value from previous frame
	gReverserDSDTimer = 0 --Reserser neutral DSD test timer
	isConfigured = false
	wiperSpeed = 0
	wiperDirection = 0
	wiperSpeedB = 0
	wiperDirectionB = 0
	gWiperSpeedFactor = 2
	isHazardLights = false
	isHazardOn = false
	gHazardTimer = 0
	gCombinedControllerPosition = 0
	gThrottleSetting = 0
	gTargetRPM = 300
	gCurrentAmps = 0
	gMaxSafeThrottle = 0
	gWiperDelay = 0
	gBlindFrame = 0
	gLastRPM = 0
	gPassComWarnTimer = 0
	gPassComVehicle = 0
	gPassComResetTimer = 0
	gFireAlarmResetTimer = 0
	gFireVehicle = 0
	gTMSMode = 2
	gBootState = 145
	gBootStartTime = 0
	gLastKeyValue = 0
	gAnomalyFlashTimer = 0
	gEmergencyBrakeTimer = 0
	isEmergencyBrake = false
	isBrakeFault = false
	gBrakeLeakFactor = 0
	gBrakeFaultResetTimer = 0
	isEmergencyStop = false
	gReverserRPMRise = 0
	gTMSTimeOut = 0
	gLastSpeed = 0
	isMRPressureLow = false
	isHillStart = false
	
	gSlowSpeedNotch = 0
	gCurrentSpeed = 0
	gSlowSpeedSet = 1.34112 
	gSlowSpeedWaitTime = 0
	isSlowSpeedActive = false
	gEngineFailCount = 0
	isPassComTriggered = false
	isPassComBrakeApplied = false
	isBrakeOverrideActive = false
	gBrakeOverrideTimer = 0
	gEmergencyBrakeStack = 0
	isFireAlarmTriggered = false
	isBooting = true
	isBISOn = true
	isColdStart = false
	mrReduction = 0
	
	gAnomaly = {}
    for i=1, 4 do
      gAnomaly[i] = 0
    end	

	gLastLogTime = 0

	gSpeedMPH = 0 --Current speed (mph)
	gSpeedMS = 0 --Current speed (m/s)
	gReverserPos = 0 --Current reverser position
	gCabThrottlePos = 0 --Current cab throttle position
	gSimThrottlePos = 0 --Current sim throttle position
	gLastThrottlePos = 0 --Previous throttle position
	
	MR_PRESSURE_NORMAL = 9.65
	
	RPM_IDLE = 300
	RPM_MAX = 1800

	--Wiper Sweeps
	FORWARD = 0
	BACKWARD = 1
	DELAY = 2
	
	--TMS Modes
	TMS_OFF = 0
	TMS_BOOTING = 1
	TMS_OVERVIEW = 2
	TMS_SCREENSAVER = 3
	
	--Boot Steps
	BOOT_COLD = 0
	BOOT_START = 1
	BOOT_ALARMS = 42
	BOOT_AWS = 48
	BOOT_TCA_OK = 52
	BOOT_TASS_TEST = 60
	BOOT_TMS_OK = 97
	BOOT_DR_OK = 98
	BOOT_SPLASH_ON = 103
	BOOT_SPLASH_OFF = 107
	BOOT_BRAKE_TEST = 110
	BOOT_TMS_L3 = 116
	BOOT_SPEEDO_TEST = 141
	BOOT_TMS_READY = 145
	
		
	Call("BeginUpdate") --Start per-frame update function


	Call( "HazardLight:Activate", 0)
	SetLights ( 0, 0, 0, 0, 0, 1, 1 )
	
	
end

function OnConsistMessage ( msg, argument, direction ) --Handles messages from other vehicles


	-- send the message further down the consist
	Call ( "SendConsistMessage", msg, argument, direction );
	
	if not isPlayerLoco then --Only when non-driven loco
	
		if ( msg == COMPAT_MSG_RPM ) then
			SetControl ( "RPM", argument )
		elseif ( msg == COMPAT_MSG_START ) then
			SetControl ( "Startup", argument )
		elseif ( msg == COMPAT_MSG_BLIND ) then
			for i = 0, 40 do
				if i == math.floor (argument + 0.5) then
					Call ( "ActivateNode", "blind"..i, 1 )
				else
					Call ( "ActivateNode", "blind"..i, 0 )
				end
			end
		elseif ( msg == COMPAT_MSG_BOOTSTATE ) then
			
			argument = argument * 1
			
			RemoteBootUp ( argument )			
			
		end
	end
	
	if ( msg == COMPAT_MSG_FAIL ) then
		
		if argument - gCoachLetter == 0 then
		
			SetControl ( "Startup", 0 )
			Call ( "SetPowerProportion", 0, 0 )
			
		end		
		
	elseif ( msg == COMPAT_MSG_COLDSTART ) and not isColdStart then
		
			isColdStart = true
			
			SetControl ( "Key", 0 )
			SetControl ( "CabReverser", 0 )
			SetControl ( "Reverser", 0 )
			
			gTMSMode = TMS_OFF
			gBootState = BOOT_COLD
			isBISOn = false
			isAWSTested = false
			isDRASet = true --DRA monitor
			
			mrReduction = MR_PRESSURE_NORMAL
			
	end
	
end

function OnCustomSignalMessage ( Parameter ) --Handles messages from scenario triggers

	if string.find(Parameter, "%d+") then --Check whether the message string contains digits
		i, j = string.find(Parameter, "%d+") --Extract the string position of the digits
		commandValue = string.sub(Parameter, i, j) --Copy them to commandValue
	end
	
	if string.find(Parameter, "%a+") then --Check whether the message string contains characters
		i, j = string.find(Parameter, "%a+") --Extract the string position of the characters
		commandName = string.sub(Parameter, i, j) --Copy them to commandName
	end

	if ( Call( "GetIsEngineWithKey" ) == 1 ) and gBootState > BOOT_ALARMS and isExpert then
	
		if commandName == "passcom" then
			SetControl ( "PassCom", 1 )
			isPassComTriggered = true
		elseif commandName == "fire" then
			SetControl ( "Fire", 2 )
			isFireAlarmTriggered = true
		elseif commandName == "brakefault" then
		
		    for i=1, 4 do
				gAnomaly[i] = gAnomaly[i] + 1
			end	

			SetControl ( "BrakeFault", 1 )
			SetControl ( "BogieFault", 1 )
			SetControl ( "TMSL3Alert", 2 )
			isBrakeFault = true
		elseif commandName == "enginefail" then
		
			
			math.randomseed ( Call( "*:GetSimulationTime" ) )
		
			failVehicle = gCoachLetter
			
			while failVehicle == gCoachLetter do
				failVehicle = math.random ( 1, 4 )
			end
						
			
			
			if failVehicle == gCoachLetter then
				SetControl ( "Startup", 0 )
				Call ( "SetPowerProportion", 0, 0 )
			else	
			
				Call( "SendConsistMessage", COMPAT_MSG_FAIL, failVehicle, 1 )
				Call( "SendConsistMessage", COMPAT_MSG_FAIL, failVehicle, 0 )
				
			end
			gAnomaly[failVehicle] = gAnomaly[failVehicle] + 1
			gEngineFailCount = gEngineFailCount + 1
			SetControl ( "TMSL3Alert", 2 )
			
		elseif commandName == "nrnbroadcast" then
			SetControl ( "NRNBroadcast", 1 )
		end
		
		
		
	end
		
	if ( Call( "GetIsEngineWithKey" ) == 1 ) and isExpert then
	
		if commandName == "coldstart" and not isColdStart then
		
			isColdStart = true
			
			gTMSMode = TMS_OFF
			gBootState = BOOT_COLD
			isBISOn = false
			isAWSTested = false
			isDRASet = true --DRA monitor
			
			mrReduction = MR_PRESSURE_NORMAL
			
			Call( "SendConsistMessage", COMPAT_MSG_COLDSTART, 1, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_COLDSTART, 1, 0 )

		end			
		
	end
	
end

function OnControlValueChange ( name, index, value )

	if Call( "*:ControlExists", name, index ) then
		Call( "*:SetControlValue", name, index, value )
	end
	
	
	if isPlayerLoco and isExpert then
	
		if name == "AWSReset" then
			SetControl ( "DSD", 0)
			gDSDCount = 0
			if isAWSTestInProgress then
				SetControl ( "AWSWarnCount", 0)
				SetControl ( "AWSClearCount", GetControl ( "AWSClearCount" ) + 1)
				SetControl ( "AWS", 1)
				isAWSTestInProgress = false
			end
		end

		if name == "CombinedController" then
		
			gDSDCount = 0
			
		end
		
		if name == "CabReverser" then
		
			gDSDCount = 0
			
			
			
			if isKeyIn and Interlock ( name, value ) then 
				if value > 2.5 and isAWSTested then 
					SetControl ( "Reverser", -1 )
				elseif value > 1.5 then
				
					SetControl ( "Reverser", 0 )
					
					if isAWSTested == false and gBootState > BOOT_ALARMS then
						SetControl ( "AWSWarnCount", 1)
						SetControl ( "AWS", 0)
						isAWSTestInProgress = true
						isAWSTested = true
					end

				elseif value > 0.5 and isAWSTested then
					SetControl ( "Reverser", 1 )
				else
					SetControl ( "Reverser", 0 )
					isAWSTested = false
				end
				
				if (value > 2.5 or ( value < 1.5 and value > 0.5 )) and isReverserDSDReset and gRunningTime > gReverserDSDTimer + 1 and isAWSTested then
					if isSafetyIsolated == false then
						SetControl ( "DSD", 1)
					end
					isReverserDSDReset = false
				elseif (value > 2.5 or value < 1.5) and isReverserDSDReset then
					isReverserDSDReset = false
				elseif value > 1.5 and value < 2.5 and isReverserDSDReset == false then
					isReverserDSDReset = true
					gReverserDSDTimer = gRunningTime
				end
				
				
			elseif not isKeyIn then
				Interlock ( name, value )
				SetControl ( "Reverser", 0 )
			end
			
		end

		if name == "Reverser" then
		
			gDSDCount = 0
			
			if isKeyIn == false then
				SetControl ( "Reverser", 0 )
			end
			
		end
		
		if name == "EmergencyStop" and value > 0.5 and not isEmergencyStop then
			gEmergencyBrakeStack = gEmergencyBrakeStack + 1
			isEmergencyStop = true
		elseif name == "EmergencyStop" and value < 0.5 and isEmergencyStop then
			gEmergencyBrakeStack = gEmergencyBrakeStack - 1
			isEmergencyStop = false			
		end
		
		if name == "DRA" and value > 0.5 then
			isDRASet = true
			SetControl ( "Regulator", 0 )
		elseif name == "DRA" and value < 0.5 then
			isDRASet = false
			SetControl ( "Regulator", GetControl ( "CabThrottle" ) )
		end
		
		if name == "Key" then
			
			if Interlock ( name, value ) then
			
				if value < 0.5 then
					SetControl ( "Reverser", 0 )
					SetControl ( "AWS", 1)
					isKeyIn = false
					isAWSTested = false
				else
					SetControl ( "Reverser", 0 )
					isKeyIn = true
				end
			
			end
			
			if not isBISOn then
				isBISOn = true
			end
			
		end

		if name == "TMSL3Reset" and GetControl ( "TMSL3Alert" ) > 1.5 then
			SetControl ( "TMSL3Alert", 1)
		end

		if name == "SafetyIsolation" then
		
			if value > 0.5 then 
				isSafetyIsolated = true
			else
				isSafetyIsolated = false
			end

			gDSDCount = 0
		
		end
		
		if name == "SlowSpeed" then
			if value > 0.5 and gSimThrottlePos < 0.01 and not isSlowSpeedActive then
				isSlowSpeedActive = true
			elseif value < 0.5 and isSlowSpeedActive then
				SetControl ( "Regulator", 0)
				isSlowSpeedActive = false
			end
		end
		
		if name == "DestinationBlind" then
			for i = 0, 40 do
				if i == math.floor (value + 0.5) then
					Call ( "ActivateNode", "blind"..i, 1 )
				else
					Call ( "ActivateNode", "blind"..i, 0 )
				end
			end
			
			Call( "SendConsistMessage", COMPAT_MSG_BLIND, value, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BLIND, value, 0 )
		end
		
		if name == "FireReset" and value > 0.5 then
		
			if GetControl ( "Fire" ) > 1.5 then
				SetControl ( "Fire", 1 )
			end
			
		end
		
		if name == "BatteryIsolationSwitch" and value > 0.5 and GetControl ( "Key" ) < 0.5 then
		
			isColdStart = true
			Call( "SendConsistMessage", COMPAT_MSG_COLDSTART, 1, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_COLDSTART, 1, 0 )
			
			gTMSMode = TMS_OFF
			gBootState = BOOT_COLD
			isBISOn = false
			isAWSTested = false
			isDRASet = true
			
			mrReduction = MR_PRESSURE_NORMAL

			SetControl ( "Key", 0 )
			SetControl ( "CabReverser", 0 )
			SetControl ( "Reverser", 0 )

		end	
		if name == "HillStart" and value > 0.5 and gSpeedMPH < 0.1 then
			isHillStart = true
		elseif name == "HillStart" and value < 0.5 then
			isHillStart = false
		end			

	else
	
	
	end
	
end

--Update function updates every frame (use of 'time' needed to get smooth animations)
function Update( time )

	
	--Detect whether the player is driving this unit
	if Call( "GetIsEngineWithKey" ) == 1 then
		isPlayerLoco = true
	else
		isPlayerLoco = false
	end
	
	--Detect whether the player is driving this consist
	if Call( "GetIsPlayer" ) == 1 then
		isPlayerConsist = true
	else
		isPlayerConsist = false
	end

	if isPlayerLoco and not isExpertChecked then
		if Call ( "IsExpertMode" ) > 0.5 then
			isExpert = true	
		else
			isExpert = false
			gTMSMode = TMS_OVERVIEW
			gBootState = BOOT_TMS_READY
			isBISOn = true
			isAWSTested = true
			isDRASet = false --DRA monitor
		end
		isExpertChecked = true
	elseif not isPlayerLoco and isExpertChecked then
		isExpertChecked = false
	end

	
	--Set global variables for commonly used control values
	gLastSpeed = gCurrentSpeed
	gCurrentSpeed = Call( "GetSpeed" )
	gSpeedMPH = GetControl ( "SpeedometerMPH" ) --Speed (MPH)
	gCurrentAmps = 	GetControl ( "Ammeter" )
	gCurrentRPM = GetControl ( "RPM" ) --Engine RPM
	gRunningTime = gRunningTime + time --Increment the running time
	
	
	if isPlayerLoco then
		gReverserPos = GetControl ( "Reverser" ) --Reverser position
		gCabThrottlePos = GetControl ( "ThrottleAndBrake" ) --Throttle position
		gSimThrottlePos = GetControl ( "Regulator" ) --Throttle position
	end
	
	--Get the speed in metres per second
	gSpeedMS = Call( "GetSpeed" )
	if gSpeedMS < 0 then
		gSpeedMS = gSpeedMS * -1
	end
	
	if isHazardLights then
		HazardLights ( time )
	end

	LightControl ()
	
	if not isConfigured then	
		InitialConfig (time)
	end

	DoorInterlock (time)

	MainReservoir ( time )

	if isPlayerLoco then --Only execute if the player is driving this vehicle
	
		WiperControl ( time )
		if isExpert then
			PowerBrakeControl ( time )
			if isSlowSpeedActive then SlowSpeedControl ( time )	end
			DriverReminderAppliance (time)
			DriverSafetyDevice (time)
			EngineControl (time)
			if isPassComTriggered then PassCom ( time ) end
			if isFireAlarmTriggered then FireAlarm ( time )	end
			if isBrakeFault then BrakeFault ( time ) end
			BrakeOverride ( time )
			BootUp ( time ) 

		end
	
	end
	
	if isPlayerConsist then --Only execute if the player is driving a vehicle in this consist
	
		TMS ( time )
		if isExpert then
		end
	
	end
	AudioControl ( time )
	
	ExhaustControl (time)
end 

function InitialConfig ( time )

	if gRunningTime > 0.5 and not isConfigured then
	
		for i = 1, 40 do
			Call ( "ActivateNode", "blind"..i, 0 )
		end
	
		SetControl ( "Headlights", 7 )
		SetLights ( 0, 0, 0, 0, 0, 1, 1 )
		isHazardLights = false
		
		--Read value of Key and setup
		value = GetControl ( "Key" )
		
		if value < 0.5 then
			isKeyIn = false
		else
			isKeyIn = true
		end
		
		--Read value of Reverser and setup
		value = GetControl ( "CabReverser" )
		
		if isKeyIn then 
			if value > 2.5 then 
				SetControl ( "Reverser", -1 )
				isAWSTested = true
			elseif value > 1.5 then
				SetControl ( "Reverser", 0 )
				isAWSTested = true
			elseif value > 0.5 then
				SetControl ( "Reverser", 1 )
				isAWSTested = true
			else
				SetControl ( "Reverser", 0 )
				isAWSTested = false
			end
		else
			SetControl ( "Reverser", 0 )
		end
		
		--Read value of DRA and setup
		value = GetControl ( "DRA" )
		if value > 0.05 then
			isDRASet = true
		else
			isDRASet = false
		end
		
		if not isExpert then 
			SetControl ( "DRA", 0 ) 
			SetControl ( "FM1200", 1 )
		end
		
		if isColdStart then
			isBISOn = false
		end
		
		isConfigured = true
	end		

end

-- Function to handle interlocking of key, reverser and power/brake controller
function Interlock ( name, value )

	local isset = false
	local currentkey = 0
	local currentreverser = 0
	local currentpowerbrake = 0

	if name == "Key" then
		currentkey = value
		currentreverser = GetControl ( "CabReverser" )
		currentpowerbrake = GetControl ( "ThrottleAndBrake" )
	elseif name == "CabReverser" then
		currentkey = GetControl ( "Key" )
		currentreverser = value
		currentpowerbrake = GetControl ( "ThrottleAndBrake" )
	else
		return
	end
	
	local newkey = currentkey
	local newreverser = currentreverser

	
	if name == "Key" then
		-- Key interlock. First of all check the reverser. If it isn't at "Off" then the key must be in.
		if currentreverser < 0.5 then
			gLastKeyValue = currentkey
			isset = true
		elseif math.floor( currentkey + 0.5 ) == currentkey then
			newkey = 1 
			SetControl ( "Key", newkey )
		end
	elseif name == "CabReverser" then
		-- We need to know if the key is in and the throttle out of the power range before we can move the reverser.
		if currentkey > 0.5 and currentpowerbrake < 0.5 then
			gLastReverserValue = currentreverser -- Save the current reverser position for interlocking
			isset = true
		elseif math.floor( currentreverser + 0.5 ) == currentreverser then
			newreverser = gLastReverserValue -- If reverser movement isn't allowed put the reverser back into the previously saved condition
			SetControl ( "CabReverser", newreverser )
		end
	else
	end
	
	return isset
	
end

function MainReservoir ( time )

	if GetControl ( "Startup" ) < 0.5 and mrReduction < MR_PRESSURE_NORMAL then
		mrReduction = mrReduction + ( 0.01 * time )
	elseif GetControl ( "Startup" ) > 0.5 and mrReduction > 0 then
		mrReduction = mrReduction - ( 0.05 * time )
	end
	
	if mrReduction > 3 and not isBrakeFault and isBISOn then
		SetControl ( "BrakeFault", 1 )
		isMRPressureLow = true
	elseif mrReduction > 3 and not isBrakeFault then
		isMRPressureLow = true
	elseif not isBrakeFault then
		isMRPressureLow = false
		SetControl ( "BrakeFault", 0 )
	end
	
	SetControl ( "VirtualMainRes", ( GetControl ( "MainReservoirPressureBAR" ) - mrReduction ) ) 

end

function AudioControl ( time )

	if GetControl ( "Reverser" ) > 0.5 or GetControl ( "Reverser" ) < -0.5 then
		if gReverserRPMRise < 200 then
			gReverserRPMRise = gReverserRPMRise + ( 200 * time )
		end
	else
		if gReverserRPMRise > 0 then
			gReverserRPMRise = gReverserRPMRise - ( 200 * time )
		end
	end
	
	if gCurrentRPM > 298 then
		SetControl ( "AudioRPM", gCurrentRPM + ( gReverserRPMRise * ( ( 1800 - gCurrentRPM ) / 1500 ) ) )
	else
		SetControl ( "AudioRPM", gCurrentRPM + ( gReverserRPMRise * ( gCurrentRPM  / 298  ) ) )
	end
	

end

function TMS ( time ) --TMS Screen Mode Control

	if gTMSMode == TMS_OVERVIEW then
	
		gTMSTimeOut = gTMSTimeOut + time
		
		if GetControl ( "TMSL3Alert" ) > 1.5 or GetControl ( "TMSTouch" ) > 0.5 then
			gTMSTimeOut = 0
		end		
		
		if gTMSTimeOut > 300 then
		
			gTMSMode = TMS_SCREENSAVER
			
		end
		
	elseif gTMSMode == TMS_SCREENSAVER then
	
		if GetControl ( "TMSL3Alert" ) > 1.5 or GetControl ( "TMSTouch" ) > 0.5 then
			gTMSTimeOut = 0
			gTMSMode = TMS_OVERVIEW
		end		
		
		if gLastSpeed >= 0.01 and gCurrentSpeed < 0.01 then
			gTMSTimeOut = 0
			gTMSMode = TMS_OVERVIEW
		end		
	end
	
		

	if gTMSMode == TMS_OFF then
		SetControl ( "TMS", 0 )
		Call( "ScreenLight:Activate", 0)
	elseif gTMSMode == TMS_BOOTING then
		SetControl ( "TMS", 1 )
		Call( "ScreenLight:Activate", 1)
	elseif gTMSMode == TMS_OVERVIEW then
	
		SetControl ( "TMS", 2 )
		Call( "ScreenLight:Activate", 1)
		
		anomalyCount = 0
	
		for i = 1, 4 do
			
			if gAnomaly[i] > 0 then
			
				anomalyCount = anomalyCount + 1
			
				if gAnomalyFlashTimer > 1 then
					SetControl ( "Anomaly"..i, 1 )
				else
					SetControl ( "Anomaly"..i, 2 )
				end
				
			else
			
				SetControl ( "Anomaly"..i, 0 )
				
			end
			
		end
		
		if anomalyCount > 0 then
			
			if gAnomalyFlashTimer > 1 then
				SetControl ( "AnomalyMaster", 1 )
			else
				SetControl ( "AnomalyMaster", 2 )
			end
				
		else
			
			SetControl ( "AnomalyMaster", 0 )
				
		end

		
		if gAnomalyFlashTimer > 2 then
			gAnomalyFlashTimer = 0
		else
			gAnomalyFlashTimer = gAnomalyFlashTimer + time
		end
	elseif gTMSMode == TMS_SCREENSAVER then
	
		SetControl ( "TMS", 0 )
		Call( "ScreenLight:Activate", 0)
		
		for i = 1, 4 do
			SetControl ( "Anomaly"..i, 0 )
		end
		
		SetControl ( "AnomalyMaster", 0 )
	
	end
	
end

function BootUp ( time ) -- Vehicle boot sequencer

	if isBISOn then

		if  gBootState == BOOT_COLD then
			gBootStartTime = gRunningTime
			SetControl ( "TMSL3Alert", 1 )
			SetControl ( "TCAFault", 1 )
			SetControl ( "DataRecorderFault", 1 )
			SetControl ( "BrakeFault", 1 )
			SetControl ( "FM1200", 1 )
			gBootState = BOOT_START
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_ALARMS and gBootState == BOOT_START then
			SetControl ( "TMSL3Alert", 2 )
			gTMSMode = TMS_BOOTING
			gBootState = BOOT_ALARMS
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_AWS and gBootState == BOOT_ALARMS then
			if isAWSTested == false and GetControl ( "CabReverser" ) > 1.5 and GetControl ( "CabReverser" ) < 2.5 then
				SetControl ( "AWSWarnCount", 1)
				SetControl ( "AWS", 0)
				isAWSTestInProgress = true
				isAWSTested = true
			end
			gBootState = BOOT_AWS
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_TCA_OK and gBootState == BOOT_AWS then
			SetControl ( "TCAFault", 0 )
			SetControl ( "BrakeFault", 0 )
			gBootState = BOOT_TCA_OK
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_TASS_TEST and gBootState == BOOT_TCA_OK then
			gBootState = BOOT_TASS_TEST
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_TMS_OK and gBootState == BOOT_TASS_TEST then
			SetControl ( "TMSL3Alert", 0 )
			gBootState = BOOT_TMS_OK
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_DR_OK and gBootState == BOOT_TMS_OK then
			SetControl ( "DataRecorderFault", 0 )
			gBootState = BOOT_DR_OK
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_SPLASH_ON and gBootState == BOOT_DR_OK then
			gBootState = BOOT_SPLASH_ON
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_SPLASH_OFF and gBootState == BOOT_SPLASH_ON then
			gBootState = BOOT_SPLASH_OFF
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_BRAKE_TEST and gBootState == BOOT_SPLASH_OFF then
			gBootState = BOOT_BRAKE_TEST
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_TMS_L3 and gBootState == BOOT_BRAKE_TEST then
			SetControl ( "TMSL3Alert", 2 )
			gBootState = BOOT_TMS_L3
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_SPEEDO_TEST and gBootState == BOOT_TMS_L3 then
			gBootState = BOOT_SPEEDO_TEST
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif ( gRunningTime - gBootStartTime ) > BOOT_TMS_READY and gBootState == BOOT_SPEEDO_TEST then
			gTMSMode = TMS_OVERVIEW
			SetControl ( "TMSL3Alert", 0 )
			gBootState = BOOT_TMS_READY
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
			Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		elseif gBootState == BOOT_TMS_READY then
			SetControl ( "FM1200", 1 )
		end
		
	else
		SetControl ( "Startup", -1 )
		SetControl ( "TMSL3Alert", 0 )
		SetControl ( "Fire", 0 )
		SetControl ( "TCAFault", 0 )
		SetControl ( "BrakeFault", 0 )
		SetControl ( "DataRecorderFault", 0 )
		SetControl ( "BogieFault", 0 )
		SetControl ( "FM1200", 0 )
		SetControl ( "AWSWarnCount", 0)

		gBootState = BOOT_COLD
		Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 1 )
		Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, gBootState, 0 )
		gTMSMode = TMS_OFF
		
		Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, BOOT_COLD, 1 )
		Call( "SendConsistMessage", COMPAT_MSG_BOOTSTATE, BOOT_COLD, 0 )

		
		for i = 1, 4 do
			SetControl ( "Anomaly"..i, 0 )
		end
		
		SetControl ( "AnomalyMaster", 0 )

	end

end

function RemoteBootUp ( bootstate ) -- Vehicle boot sequencer

	gBootState = bootstate

	if bootstate == BOOT_COLD then
		isBISOn = false
		SetControl ( "Startup", -1 )
		SetControl ( "TMSL3Alert", 0 )
		SetControl ( "Fire", 0 )
		SetControl ( "TCAFault", 0 )
		SetControl ( "BrakeFault", 0 )
		SetControl ( "DataRecorderFault", 0 )
		SetControl ( "TiltFault", 0 )
		SetControl ( "BogieFault", 0 )
		SetControl ( "FM1200", 0 )
		SetControl ( "AWSWarnCount", 0)

		gTMSMode = TMS_OFF
		
		for i = 1, 5 do
			SetControl ( "Anomaly"..i, 0 )
		end
		
		SetControl ( "AnomalyMaster", 0 )
	
	elseif bootstate == BOOT_START then
		isBISOn = true
		gBootStartTime = gRunningTime
		SetControl ( "TMSL3Alert", 1 )
		SetControl ( "TCAFault", 1 )
		SetControl ( "DataRecorderFault", 1 )
		SetControl ( "BrakeFault", 1 )
		SetControl ( "FM1200", 1 )
	elseif bootstate == BOOT_ALARMS then
		SetControl ( "TMSL3Alert", 2 )
		gTMSMode = TMS_BOOTING
	elseif bootstate == BOOT_AWS then
		if isAWSTested == false and GetControl ( "CabReverser" ) > 1.5 and GetControl ( "CabReverser" ) < 2.5 then
			SetControl ( "AWSWarnCount", 1)
			SetControl ( "AWS", 0)
			isAWSTestInProgress = true
			isAWSTested = true
		end
	elseif bootstate == BOOT_TCA_OK then
		SetControl ( "TCAFault", 0 )
		SetControl ( "BrakeFault", 0 )
	elseif bootstate == BOOT_TASS_TEST then
	elseif bootstate == BOOT_TMS_OK then
		SetControl ( "TMSL3Alert", 0 )
	elseif bootstate == BOOT_DR_OK then
		SetControl ( "DataRecorderFault", 0 )
	elseif bootstate == BOOT_SPLASH_ON then
	elseif bootstate == BOOT_SPLASH_OFF then
	elseif bootstate == BOOT_BRAKE_TEST then
	elseif bootstate == BOOT_TMS_L3 then
		SetControl ( "TMSL3Alert", 2 )
	elseif bootstate == BOOT_SPEEDO_TEST then
	elseif bootstate == BOOT_TMS_READY then
		gTMSMode = TMS_OVERVIEW
		SetControl ( "TMSL3Alert", 0 )
	end

end

function PassCom ( time )

	gPassComWarnTimer = gPassComWarnTimer + time
	
	if gPassComVehicle == 0 then
		gPassComVehicle = math.random ( 1, 4 )
		gAnomaly[gPassComVehicle] = gAnomaly[gPassComVehicle] + 1
	end
		
		
	
	if gPassComWarnTimer > 10 and not isPassComBrakeApplied and isBISOn then
		gEmergencyBrakeStack = gEmergencyBrakeStack + 1
		SetControl ( "TMSL3Alert", 2)
		isPassComBrakeApplied = true
	end
	
	if gSpeedMS > 0.1 then
		gPassComResetTimer = 0
	else
		gPassComResetTimer = gPassComResetTimer + time
		if gPassComResetTimer > 30 then
			gEmergencyBrakeStack = gEmergencyBrakeStack - 1
			SetControl ( "PassCom", 0 )
			gPassComWarnTimer = 0
			isPassComTriggered = false
			isPassComBrakeApplied = false
			SetControl ( "TMSL3Alert", 0)
			gAnomaly[gPassComVehicle] = gAnomaly[gPassComVehicle] - 1
			if gAnomaly[gPassComVehicle] < 0 then
				gAnomaly[gPassComVehicle] = 0
			end
			gPassComVehicle = 0
		end
	end
	
	if not isBISOn then
		gEmergencyBrakeStack = 0
		SetControl ( "PassCom", 0 )
		gPassComWarnTimer = 0
		isPassComTriggered = false
		isPassComBrakeApplied = false
	end
end

function FireAlarm ( time )

	if gFireVehicle == 0 then
		gFireVehicle = math.random ( 1, 4 )
		gAnomaly[gFireVehicle] = gAnomaly[gFireVehicle] + 1
	end

	if gSpeedMS > 0.1 then
		gFireAlarmResetTimer = 0
	else
		gFireAlarmResetTimer = gFireAlarmResetTimer + time
		if gFireAlarmResetTimer > 30 then
			SetControl ( "Fire", 0 )
			isFireAlarmTriggered = false
			gAnomaly[gFireVehicle] = gAnomaly[gFireVehicle] - 1
			if gAnomaly[gFireVehicle] < 0 then
				gAnomaly[gFireVehicle] = 0
			end
			gFireVehicle = 0

		end
	end
	
	if not isBISOn then
		SetControl ( "Fire", 0 )
		isFireAlarmTriggered = false
	end

end

function BrakeFault ( time )


	if gBrakeLeakFactor < 1 then 
		gBrakeLeakFactor = gBrakeLeakFactor + ( time  / 60 ) 
	end
	
	if gCurrentSpeed < 0.01 then
		gBrakeFaultResetTimer = gBrakeFaultResetTimer + time
	else
		gBrakeFaultResetTimer = 0
	end
	
	if gBrakeFaultResetTimer > 30 then
		gBrakeLeakFactor = 0
		SetControl ( "BrakeFault", 0 )
		SetControl ( "BogieFault", 0 )
		SetControl ( "TMSL3Alert", 0 )
		for i =  1, 4  do
			gAnomaly[i] = gAnomaly[i] - 1
		end

		isBrakeFault = false
	end
		
	
	
	
end


function BrakeOverride ( time )

	if gEmergencyBrakeStack < 0 then
		gEmergencyBrakeStack = 0
	end
	
	if GetControl ( "BrakeOverride" ) > 0.5 and gEmergencyBrakeStack > 0 then
		isEmergencyBrake = false
		isBrakeOverrideActive = true
	end
	
	if GetControl ( "BrakeOverride" ) < 0.5 and isBrakeOverrideActive then
		gBrakeOverrideTimer = gBrakeOverrideTimer + time
		isEmergencyBrake = false
		if gBrakeOverrideTimer > 30 then
			isBrakeOverrideActive = false
			gBrakeOverrideTimer = 0
		end
	else
		if gEmergencyBrakeStack > 0 then
			isEmergencyBrake = true
		elseif gCurrentSpeed < 0.01 and gReverserPos == 0 then
			isEmergencyBrake = false
		end
	end

end

function ExhaustControl (time)

	if GetControl ( "Startup" ) < 0.5 then
		SetControl ( "RPM", 0 )
	end		

	if GetControl ( "RPM" ) > gLastRPM and gLastRPM < 299 and gLastRPM > 75 then
		Call( "ScriptExhaustRev:SetEmitterActive", 1 )
	else
		Call( "ScriptExhaustRev:SetEmitterActive", 0 )
	end
	
	if GetControl ( "RPM" ) > 1600 and gSpeedMS < 0.5 then
		Call( "ScriptExhaustLoad:SetEmitterActive", 1 )
	else
		Call( "ScriptExhaustLoad:SetEmitterActive", 0 )
	end
	
	if gLastRPM > 1750 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 1 )
	elseif gLastRPM > 1650 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 1 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1550 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 1 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1450 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 1 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1350 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 1 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1150 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 1 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 750 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 1 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 650 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 1 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 250 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 1 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	else
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	end

	gLastRPM = GetControl ( "RPM" )
	
	if isPlayerLoco then	
		Call( "SendConsistMessage", COMPAT_MSG_RPM, gLastRPM, 1 )
		Call( "SendConsistMessage", COMPAT_MSG_RPM, gLastRPM, 0 )
	end

end


function DoorInterlock (time)

	if (GetControl ( "DoorsOpenCloseLeft" ) > 0.99 or GetControl ( "DoorsOpenCloseRight" ) > 0.99) and isDoorsInterlocked then
		isDoorsInterlocked = false
		gDoorInterlockTimer = 0
	elseif (GetControl ( "DoorsOpenCloseLeft" ) < 0.01 and GetControl ( "DoorsOpenCloseRight" ) < 0.01) and isDoorsInterlocked == false then
		gDoorInterlockTimer = gDoorInterlockTimer + time
		if gDoorInterlockTimer > 17 then 
			isDoorsInterlocked = true
		end
	else 
		gDoorInterlockTimer = 0
	end
	
	if isDoorsInterlocked then
		SetControl ( "DoorInterlock", 1 )
		Call ( "ActivateNode", "doorlights", 0 )
		Call( "InterlockLeft:Activate", 0)			
		Call( "InterlockRight:Activate", 0)			
	else
		SetControl ( "DoorInterlock", 0 )
		Call ( "ActivateNode", "doorlights", 1 )
		Call( "InterlockLeft:Activate", 1)			
		Call( "InterlockRight:Activate", 1)			
	end
	
	if gBootState > BOOT_START then
	
		if GetControl ( "DoorsOpenCloseLeft" ) < 0.01 and isDoorsInterlocked then
			SetControl ( "DoorsLockedLeft", 1 )
		else
			SetControl ( "DoorsLockedLeft", 0 )
		end
			
		if GetControl ( "DoorsOpenCloseRight" ) < 0.01 and isDoorsInterlocked then
			SetControl ( "DoorsLockedRight", 1 )
		else
			SetControl ( "DoorsLockedRight", 0 )
		end
		
	else
	
		SetControl ( "DoorsLockedLeft", 0 )
		SetControl ( "DoorsLockedRight", 0 )
		
	end

end


function WiperControl ( time )

	wiperPosition = GetControl ( "WiperBlades" ) 
	wiperSpeed = GetControl ( "Wipers" )
	
	if wiperSpeed > 2.5 and isBISOn then
		if wiperDirection == FORWARD then
			if wiperPosition < 1 then
				wiperPosition = wiperPosition + ( time * gWiperSpeedFactor )
			else
				wiperDirection = BACKWARD
			end
		else
			if wiperPosition > 0 then
				wiperPosition = wiperPosition - ( time * gWiperSpeedFactor )
			else
				wiperDirection = FORWARD
			end
		end
	elseif wiperSpeed > 1.5 and isBISOn then
		if wiperDirection == FORWARD then
			if wiperPosition < 1 then
				wiperPosition = wiperPosition + ( time * gWiperSpeedFactor * 0.6 )
			else
				wiperDirection = BACKWARD
			end
		else
			if wiperPosition > 0 then
				wiperPosition = wiperPosition - ( time * gWiperSpeedFactor * 0.6 )
			else
				wiperDirection = FORWARD
			end
		end
	elseif wiperSpeed > 0.5 and wiperPosition > 0 and isBISOn then
		wiperPosition = wiperPosition - ( time * gWiperSpeedFactor * 0.1 )
	elseif wiperSpeed < 0.5 and isBISOn then
		if wiperDirection == FORWARD then
			if wiperPosition < 1 then
				wiperPosition = wiperPosition + ( time * gWiperSpeedFactor * 0.6 )
			else
				wiperDirection = BACKWARD
			end
		elseif wiperDirection == BACKWARD then
			if wiperPosition > 0 then
				wiperPosition = wiperPosition - ( time * gWiperSpeedFactor * 0.6 )
			else
				wiperDirection = DELAY
			end
		elseif wiperDirection == DELAY then
			if gWiperDelay < 5 then
				gWiperDelay = gWiperDelay + time
			else
				if wiperPosition < 0.1 then
					wiperDirection = FORWARD
				else
					wiperDirection = BACKWARD
				end
				gWiperDelay = 0
			end

		end
	end	
	
	SetControl ( "WiperBlades", wiperPosition )
	
	Call( "*:Reset", "externalwipers" )
	Call( "*:AddTime", "externalwipers", wiperPosition * 0.6)
	
end

function PowerBrakeControl ( time )

	if GetControl ( "WheelSlip" ) > 0.99 then
		isSlipping = true
	end

	gCombinedControllerPosition = GetControl ( "ThrottleAndBrake" )
	
	if gCombinedControllerPosition < 0.5 and not isEmergencyBrake and not isMRPressureLow then 
		SetControl ( "Regulator", 0)
		brakePosition = 1 - ( gCombinedControllerPosition * 2 )
		gThrottleSetting = 0
	elseif not isEmergencyBrake  and not isMRPressureLow then
	
		if isHillStart then
		
			brakePosition = 0.3
			
			if gSpeedMPH > 1 then
				isHillStart = false
				SetControl ( "HillStart", 0)
			end
			
		else
		
			brakePosition = 0
			
		end
		
		gThrottleSetting = ( gCombinedControllerPosition - 0.5 ) * 2 
	elseif not isEmergencyBrake then
		SetControl ( "Regulator", 0)
		brakePosition = 0.5
		gThrottleSetting = 0
	else
		brakePosition = 1
	end	
	
	if brakePosition < 0.75 then
		if gSpeedMPH > 60 then
			SetControl ( "TrainBrakeControl", ( brakePosition * 1.17 * 0.7 ) + gBrakeLeakFactor )
		else
			SetControl ( "TrainBrakeControl", ( brakePosition * 1.17 ) + gBrakeLeakFactor )
		end
	elseif brakePosition < 0.99 then
		if gSpeedMPH > 60 then
			SetControl ( "TrainBrakeControl", ( 0.8 * 0.7 ) + gBrakeLeakFactor )
		else
			SetControl ( "TrainBrakeControl", 0.8 + gBrakeLeakFactor )
		end
	else
		SetControl ( "TrainBrakeControl", 1 )
	end
	
	
	if gCurrentAmps < 125 and not isSlipping then
		gMaxSafeThrottle = gThrottleSetting
	elseif ( gCurrentAmps > 130 or isSlipping ) and gThrottleSetting > gMaxSafeThrottle - 0.01 then
		gThrottleSetting = gMaxSafeThrottle - ( 0.1 * time )
		gMaxSafeThrottle = gThrottleSetting
	elseif gThrottleSetting < gMaxSafeThrottle - 0.01 then
		gMaxSafeThrottle = gThrottleSetting
	else	
		gThrottleSetting = gMaxSafeThrottle
	end	
	
	
	
	
	--This block sets the sim throttle to match the position of the cab control
	if (gReverserPos > 0.5 or gReverserPos < -0.5) and isAWSTested and not isDRASet and not isEmergencyBrake then --Only take power if the various interlocks are set correctly
		SetControl ( "Regulator", gThrottleSetting )
	else --Otherwise close the throttle
		SetControl ( "Regulator", 0 )
	end
	
	

end

function SlowSpeedControl (time)

	if GetControl ( "Reverser" ) > -0.5 and GetControl ( "Reverser" ) < 0.5 then
		SetControl ( "Regulator", 0)
		gSlowSpeedNotch = 0
		return
	end
	
	if gCurrentSpeed < gSlowSpeedSet - 0.03 and gRunningTime > gSlowSpeedWaitTime then
		gSlowSpeedWaitTime = gRunningTime + 6
		gSlowSpeedNotch = gSlowSpeedNotch + 1
	end
	
	if gSlowSpeedNotch > 20 then
		gSlowSpeedNotch = 20
	end
	
	if gCurrentSpeed > (gSlowSpeedSet + 0.03) then
		gSlowSpeedNotch = 0
	end
	

			
	SetControl ( "Regulator", gSlowSpeedNotch/20 )

end

function DriverReminderAppliance (time)

	if isDRASet then
		SetControl ( "Regulator", 0)
	end		

end

function EngineControl (time)

	if GetControl ( "StartButton" ) > 0.1 then
		SetControl ( "Startup", 1 )
		Call( "SendConsistMessage", COMPAT_MSG_START, 1, 1 )
		Call( "SendConsistMessage", COMPAT_MSG_START, 1, 0 )
	elseif GetControl ( "StopButton" ) > 0.1 then
		SetControl ( "Startup", -1 )
		Call( "SendConsistMessage", COMPAT_MSG_START, 0, 1 )
		Call( "SendConsistMessage", COMPAT_MSG_START, 0, 0 )
	end

end

-- Driver's Safety Device
function DriverSafetyDevice (time)

	-- If an emergency brake application has occurred, reset once the train is stationary
	if gCurrentSpeed < 0.01 and isDSDTriggered then
		gEmergencyBrakeStack = gEmergencyBrakeStack - 1
		isDSDTriggered = false
	end
	
	-- If the reverser is in neutral then disable DSD
	if GetControl ( "Reverser" ) == 0 then
		isDSDTriggered = false
		return
	end
	
	-- If DSD warning has been active for 5 seconds with no response then cut power and trigger emergency brake
	if gDSDCount > DSDDELAY + 5 and not isDSDTriggered and not isSafetyIsolated and isBISOn then
		isDSDTriggered = true
		gEmergencyBrakeStack = gEmergencyBrakeStack + 1
		SetControl ( "Regulator", 0 )
	
	-- If DSD timer has expired then sound DSD alarm
	elseif gDSDCount > DSDDELAY and not isSafetyIsolated and isBISOn then
		SetControl ( "DSD", 1)
	end
	
	-- Increment DSD timer
	gDSDCount = gDSDCount + time

end



---------------------------------------------------------------------------
function LightControl () --Switches on/off the various cab light sources --
---------------------------------------------------------------------------

	----------------
	-- CAB LIGHTS --
	----------------

	if isPlayerLoco then

		-- Clipboard
		if GetControl ( "ClipboardLight" ) > 0.5 and isBISOn then
			Call( "ClipboardLight:Activate", 1)
		else
			Call( "ClipboardLight:Activate", 0)
		end
		
		-- DRA
		if isDRASet and isBISOn then
			Call( "DRALight:Activate", 1)
		else
			Call( "DRALight:Activate", 0)
		end
		
		-- Gauge Lamps
		if GetControl ( "InstrumentLights" ) > 0.5 and isBISOn then
			Call( "GaugeLight1:Activate", 1)
			Call( "GaugeLight2:Activate", 1)
			Call( "GaugeLight3:Activate", 1)
		else
			Call( "GaugeLight1:Activate", 0)
			Call( "GaugeLight2:Activate", 0)
			Call( "GaugeLight3:Activate", 0)
		end
		
		-- Overhead Light
		if GetControl ( "CabLights" ) > 0.5 and isBISOn then
			Call( "CabLight:Activate", 1)
		else
			Call( "CabLight:Activate", 0)
		end
		
	else
	
		Call( "ClipboardLight:Activate", 0)
		Call( "DRALight:Activate", 0)
		Call( "GaugeLight1:Activate", 0)
		Call( "GaugeLight2:Activate", 0)
		Call( "GaugeLight3:Activate", 0)
		Call( "CabLight:Activate", 0)
		
	end

		
	---------------------
	-- EXTERNAL LIGHTS --
	---------------------
	
	if isPlayerLoco then
	
		switchValue = GetControl ( "Headlights" )

		if switchValue > 6.5 then --Tail
			SetLights ( 0, 0, 0, 0, 0, 1, 1 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		elseif switchValue > 5.5 then --Hazard
			isHazardLights = true
			SetControl ( "BrakeLeak", 1 )
		elseif switchValue > 4.5 then --Night Back Up
			SetLights ( 1, 0, 1, 1, 0, 0, 0 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		elseif switchValue > 3.5 then --Day Back Up
			SetLights ( 1, 1, 0, 0, 1, 0, 0 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		elseif switchValue > 2.5 then --Night
			SetLights ( 1, 1, 0, 0, 1, 0, 0 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		elseif switchValue > 1.5 then --Day
			SetLights ( 1, 0, 1, 1, 0, 0, 0 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		elseif switchValue > 0.5 then --Markers
			SetLights ( 1, 1, 1, 0, 0, 0, 0 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		else
			SetLights ( 0, 0, 0, 0, 0, 0, 0 ) --Off
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		end
	
	elseif not isPlayerLoco then
	
		if Call("GetSpeed") > 0.05 then
			SetLights ( 1, 0, 1, 1, 0, 0, 0 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		elseif Call("GetSpeed") < -0.05 then
			SetLights ( 0, 0, 0, 0, 0, 1, 1 )
			isHazardLights = false
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
		end
	
	end
	
	

	
end

function HazardLights ( time )

	if gHazardTimer > 0.75 then
		gHazardTimer = 0
		if isHazardOn then
			SetLights ( 1, 0, 0, 0, 0, 0, 0 )
			SetControl ( "HazardLit", 0 )
			Call( "HazardLight:Activate", 0)
			isHazardOn = false
		else
			SetLights ( 1, 0, 0, 1, 1, 0, 0 )
			SetControl ( "HazardLit", 1 )
			Call( "HazardLight:Activate", 1)
			isHazardOn = true
		end
	else
		gHazardTimer = gHazardTimer + time
	end		

end

function SetLights ( marker1, marker2, marker3, head1, head2, tail1, tail2 )

	Call ( "ActivateNode", "marker1", marker1 )
	Call( "MarkerCentre:Activate", marker1)
	Call ( "ActivateNode", "marker2", marker2 )
	Call( "MarkerRight:Activate", marker2)			
	Call ( "ActivateNode", "marker3", marker3 )
	Call( "MarkerLeft:Activate", marker3)			
	Call ( "ActivateNode", "head1", head1 )
	Call( "HeadlightRight:Activate", head1 )			
	Call ( "ActivateNode", "head2", head2 )
	Call( "HeadlightLeft:Activate", head2 )
	Call ( "ActivateNode", "tail1", tail1 )
	Call( "TailRight:Activate", tail1)			
	Call ( "ActivateNode", "tail2", tail2 )
	Call( "TailLeft:Activate", tail2)			

end
-- Function to set a named control to the correct value if the control exists - used to keep code compact.
function SetControl ( name, value )

	if Call( "*:ControlExists", name, 0 ) then
		Call( "*:SetControlValue", name, 0, value )
		return true
	else
		return false
	end

end

-- Function to get a named control value if the control exists - used to keep code compact.
function GetControl ( name )

	if Call( "*:ControlExists", name, 0 ) then
		return Call( "*:GetControlValue", name, 0 )
	else
		return 0
	end

end

-- Function to log to a debug file
function DebugFile ( message )

	local timehundredths = math.floor ( gRunningTime * 100 ) / 100

	if isDebugOn then
		file:write ( timehundredths..": "..message.."\n" )
	end
end
